/*
 * adc.h
 *
 * Created: 27.5.2013 21:56:17
 *  Author: xkralj07
 */ 


#ifndef ADC_H_
#define ADC_H_

#define AdcInit()			\
do {						\
	ADCSRA = _BV(ADIE) | _BV(ADPS1);					/* enable interrupt and set prescaler to 1/4 */			\
	DIDR0 = _BV(ADC0D) | _BV(ADC1D) | _BV(ADC2D) |																\
		_BV(ADC3D) | _BV(ADC6D);						/* disable digital inputs of exclusively analog pins */	\
} while (0)

#define AdcEnable()			\
do {						\
	PRR &= ~_BV(PRADC);		/* enable clock for ADC */	\
	ADCSRA |= _BV(ADEN);	/* enable ADC */			\
} while (0)

#define AdcDisable()		\
do {						\
	PRR |= _BV(PRADC);		/* disable clock for ADC */	\
	ADCSRA &= ~_BV(ADEN);	/* disable ADC */			\
} while (0)

#define AdcSetRef_5v()			ADMUX |=  REFS0;
#define AdcRef_1v1()			ADMUX &= ~REFS0;

#define AdcMuxSelCharCur()		(ADMUX = (ADMUX & 0xf0) | 0)
#define AdcMuxSelLoadCur()		(ADMUX = (ADMUX & 0xf0) | 1)
#define AdcMuxSelCharV()		(ADMUX = (ADMUX & 0xf0) | 2)
#define AdcMuxSelAccuV()		(ADMUX = (ADMUX & 0xf0) | 3)
#define AdcMuxSelOutSense()		(ADMUX = (ADMUX & 0xf0) | 6)
#define AdcMuxSelILimited()		(ADMUX = (ADMUX & 0xf0) | 7)
#define AdcMuxSelTemp()			(ADMUX = (ADMUX & 0xf0) | 8)

#define AdcNoiseSleep()		\
do {						\
	set_sleep_mode(SLEEP_MODE_ADC);		/* set sleep mode for ADC */							\
	sleep_bod_disable();				/* disable brown-out detector during sleep mode */		\
	sleep_cpu();			\
} while (0)

#define AdcGetValue()			(ADC)



#endif /* ADC_H_ */