/*
 * btns_led.h
 *
 * Created: 27.5.2013 20:13:14
 *  Author: xkralj07
 */ 


#ifndef BTNS_LED_H_
#define BTNS_LED_H_

#define OUT_BTN_PIN			PIND2
#define LCD_BTN_PIN			PIND3
#define LED_OUT_PIN			PIND4

#define BtnsLedInit()			\
do {							\
	DDRD |= _BV(LED_OUT_PIN);						/* set LED pin as output */	\
	PORTD |= _BV(OUT_BTN_PIN) | _BV(LCD_BTN_PIN);	/* pull-up to inputs */		\
	EICRA = 0;										/* the low level of INT 0 and INT 1 generates interrupt */	\
	EIMSK = _BV(INT0) | _BV(INT1);					/* enable interrupt request from INT 0 and INT 1 */			\
} while (0)

#define BtnSetInt0SensLowLevel()	(EICRA &= ~(_BV(ISC01) | _BV(ISC00)))
#define BtnSetInt1SensLowLevel()	(EICRA &= ~(_BV(ISC11) | _BV(ISC10)))
#define BtnSetInt0SensRisingEdge()	(EICRA |= _BV(ISC01) | _BV(ISC00))
#define BtnSetInt1SensRisingEdge()	(EICRA |= _BV(ISC11) | _BV(ISC10))

#define IsBtnSetInt0SensLowLevel()	(!(EICRA & (_BV(ISC01) | _BV(ISC00))))
#define IsBtnSetInt1SensLowLevel()	(!(EICRA & (_BV(ISC11) | _BV(ISC10))))

#define BtnEnableInt0()		(EIMSK |=  _BV(INT0))
#define BtnEnableInt1()		(EIMSK |=  _BV(INT1))
#define BtnEnableInt01()	(EIMSK |=  _BV(INT0) | _BV(INT1))
#define BtnDisableInt0()	(EIMSK &= ~_BV(INT0))
#define BtnDisableInt1()	(EIMSK &= ~_BV(INT1))
#define BtnClearInt0()		(EIFR  |=  _BV(INT0))
#define BtnClearInt1()		(EIFR  |=  _BV(INT1))



#define LedOutSetOn()		(PORTD &= ~_BV(LED_OUT_PIN))		/* led is active low */
#define LedOutSetOff()		(PORTD |=  _BV(LED_OUT_PIN))




#endif /* BUTTONS_H_ */